--[[
	兵种特惠的数据模块
]]

DataSoldierSale = {}

local s_SoldierSaleState = 1
local s_SoldierSaleId = 0
local s_SoldierSaleReward = 1
local s_SoldierSaleCompleteNum = 3
local s_SoldierSaleMaxNum = 3
local s_SoldierSaleValue = 0.1
local s_SoldierSaleResList = {}
local s_SoldierSaleEndTime = 1512534464000
local s_infoData = nil

local function updateSoldierSale( allData )
	if (allData) then
		s_SoldierSaleState = allData.armyStatus
		s_SoldierSaleId = allData.armyId
		s_SoldierSaleEndTime = allData.overTime
		s_SoldierSaleReward = allData.receiveStatus
		s_SoldierSaleCompleteNum = allData.winTimes
		s_SoldierSaleMaxNum = allData.requireWinTimes
		s_SoldierSaleValue = allData.discountRate

		local resStr = allData.resource
		s_SoldierSaleResList = {}
	    for rewardStr in string.gmatch(resStr, "(%d+)|*") do
	        table.insert(s_SoldierSaleResList, rewardStr)
	    end

	end
end

function DataSoldierSale.init( allData )
	updateSoldierSale(allData)
end

function DataSoldierSale.update( allData )
	updateSoldierSale(allData)
end

function DataSoldierSale.getSoldierSaleId()
	return s_SoldierSaleId
end

function DataSoldierSale.getSoldierSaleCompleteNum()
	return s_SoldierSaleCompleteNum
end

function DataSoldierSale.getSoldierSaleMaxNum()
	return s_SoldierSaleMaxNum
end

function DataSoldierSale.getSoldierSaleEndTime()
	return s_SoldierSaleEndTime
end

function DataSoldierSale.getSoldierSaleValue()
	return s_SoldierSaleValue
end

function DataSoldierSale.getSoldierSaleInfo( index )
	return s_SoldierSaleResList[index]
end

function DataSoldierSale.IsVisible()
	if (s_SoldierSaleState==1) then
		return true
	else
		return false
	end
end

function DataSoldierSale.SoldierSaleRewardState()
	return s_SoldierSaleReward
end

function DataSoldierSale.IsReward()
	if(s_SoldierSaleReward==1)then
		return true
	else
		return false
	end
end

function DataSoldierSale_getSoldierSaleID()
	if (s_SoldierSaleState==1) then
		return s_SoldierSaleId
	else
		return 0
	end
end

function DataSoldierSale_getSoldierSaleValue()
	return s_SoldierSaleValue*100
end

function DataSoldierSale_getSoldierSaleState()
	if (s_SoldierSaleState==1) then
		return true
	else
		return false
	end
end

function DataSoldierSale_IsVisibleIcon()
	if(s_SoldierSaleReward==1)then
		return true
	else
		return false
	end
end
