
local ClearMap = class("ClearMap", require("BaseView"))

local _super = ClearMap.super


local NEButtonData = AppData.NEButtonData
local clickIndex = 0
function ClearMap:ctor()
	_super.ctor(self, "ui_huodong_zdkr")
    print("ClearMap:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_CLEAEMAP_SELF_Get, self, self.refeshClearMap)
    messageManager:register(MESSAGE.JSON_CLEAEMAP_GROUP_Get, self, self.refeshClearMap)
end

function ClearMap:dtor()
    _super.dtor(self)
    print("ClearMap:dtor")
    messageManager:unregister(MESSAGE.JSON_CLEAEMAP_SELF_Get, self, self.refeshClearMap)
    messageManager:unregister(MESSAGE.JSON_CLEAEMAP_GROUP_Get, self, self.refeshClearMap)
end

function ClearMap:initView()
    local nodes = self.m_nodes
    if self.m_rootNode then
        --self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end
    clickIndex = 0
    nodes.anim1 = self.m_rootNode:getNodeByName("anim1")
    nodes.anim2 = self.m_rootNode:getNodeByName("anim2")
    nodes.tips1 = nodes.anim1:getNodeByName("tips")
    nodes.tips2 = nodes.anim2:getNodeByName("tips")

    nodes.tips1:setVisible(false)
    nodes.tips2:setVisible(false)

    local function clickOK(sender)
        local index = sender:getTag()
        local dataList = DataClearMap.getClearMapInfo(index)
        local anim = {}
        if(index==1)then
            anim = nodes.anim1
        else
            anim = nodes.anim2 
        end
        local tips = anim:getNodeByName("tips")
        nodes.tips1:setVisible(false)
        nodes.tips2:setVisible(false)
        if(dataList.curStage>=dataList.maxStage)then

        else
            if(dataList.medalNum>=dataList.nextStage)then
                local sendId = 1399+index
                messageManager:sendForJson( sendId, 0 )
                local resList = table.nums(dataList.rewardInfo)
                for j=1,resList do
                    local resDataStr = dataList.rewardInfo[j]
                    local resData = {}
                    for rewardStr in string.gmatch(resDataStr, "(%d+)=*") do
                        table.insert(resData, rewardStr)
                    end
                    local resIcon = anim:getNodeByName("animOk")
                    CPPInterfaceManager:UIEffect_FlyResourceIcon(resIcon, 0, 0, resData[1], resData[2])
                end
            else
                if(index~=clickIndex)then
                    tips:setVisible(true)
                    tips:playAnimation("arrow") 
                    clickIndex = index
                else
                    clickIndex = 0
                end
            end
        end
    end
    
    nodes.btnOk1 = nodes.anim1:getNodeByName("buttonOk")
    nodes.btnOk2 = nodes.anim2:getNodeByName("buttonOk")
    nodes.btnOk1:setTag(1)
    nodes.btnOk2:setTag(2)

    for i = 1, 2 do
        local dataList = DataClearMap.getClearMapInfo(i)
        local strLabel = "labelTime"..tostring(i)
        local anim = self.m_rootNode:getNodeByName(strAnim)

        local state = dataList.status
        local strTime = CPPInterfaceManager:LString_formateRestEndTime(dataList.timePoint)
        if(state==1)then
            self.m_rootNode:getLabelByName(strLabel):setString(getStringInLang("loc_begin_count_down")..strTime)
        elseif(state==2)then
            self.m_rootNode:getLabelByName(strLabel):setString(getStringInLang("loc_badarmy_time_left")..strTime)
        else
            self.m_rootNode:getLabelByName(strLabel):setString(getStringInLang("loc_crazy_battle_not_open"))
        end
    end

    self.m_rootNode:getLabelByName("labelInfo1"):setString(getStringInLang("loc_crazy_battle_content_1"))
    self.m_rootNode:getLabelByName("labelInfo2"):setString(getStringInLang("loc_crazy_battle_content_2"))

    setNEButtonCallBack(nodes.btnOk1, NEBattleEvent.NEButtonEventTouchUpInside, clickOK)
    setNEButtonCallBack(nodes.btnOk2, NEBattleEvent.NEButtonEventTouchUpInside, clickOK)

    self:refeshClearMap()
end

function ClearMap:refeshClearMap()
    local nodes = self.m_nodes

    for i = 1, 2 do
        local dataList = DataClearMap.getClearMapInfo(i)
        local strAnim = "anim"..tostring(i)
        local anim = self.m_rootNode:getNodeByName(strAnim)
        local tips = anim:getNodeByName("tips")
        local animOk = anim:getNodeByName("animOk")
        local state = dataList.status
        anim:useSkin("normal")
        animOk:useSkin("normal")
        if(state~=2)then
            anim:useSkin("hui")
            animOk:useSkin("hui")
        end
        if(dataList.medalNum<dataList.nextStage)then
            animOk:useSkin("hui")
        end
        if(i==2 and dataList.isJoinArmyGroup==false)then
            if(dataList.medalNum<dataList.nextStage)then
                anim:useSkin("hui")
            end
        end

        anim:getLabelByName("centerLabel"):setString(dataList.medalNum.."／"..dataList.nextStage)
        anim:getLabelByName("centerLabel2"):setString(dataList.curStage.."／"..dataList.maxStage)
        local num = dataList.medalNum
        if(dataList.medalNum>=dataList.nextStage)then
            num = dataList.nextStage
        end
        anim:getNodeByName("leftPipe"):setContentSize(cc.size((150/dataList.nextStage)*num,13))

        if(dataList.nextStage==0)then
            anim:getLabelByName("centerLabel"):setString("")
            anim:getNodeByName("leftPipe"):setContentSize(cc.size(150,13))
            anim:useSkin("hui")
            animOk:useSkin("hui")
        end
        local resList = 0
        if(dataList.rewardInfo~="")then
            resList = table.nums(dataList.rewardInfo)
        end
        for j=1,resList do
            local resDataStr = dataList.rewardInfo[j]
            local strRes = "resanim"..tostring(j)
            local resData = {}
            for rewardStr in string.gmatch(resDataStr, "(%d+)=*") do
                table.insert(resData, rewardStr)
            end
            tips:getNodeByName(strRes):useSkin(tostring(resData[1]))
            tips:getNodeByName(strRes):getLabelByName("numLabel"):setString(tostring(resData[2]))
        end
    end

end

return ClearMap
