
local SoldierSale = class("SoldierSale", require("BaseView"))

local _super = SoldierSale.super


local NEButtonData = AppData.NEButtonData

function SoldierSale:ctor()
	_super.ctor(self, "ui_huodong_bbhd")
    print("SoldierSale:ctor")
    self:initView()
    messageManager:register(MESSAGE.JSON_SOLDIER_SALE_Get, self, self.refeshSoldierSale)
end

function SoldierSale:dtor()
    _super.dtor(self)
    print("SoldierSale:dtor")
    messageManager:unregister(MESSAGE.JSON_SOLDIER_SALE_Get, self, self.refeshSoldierSale)
    animManager:unusedSpriteframesFromPath("yasuo_ui_" .. Util.GetNationName(CPPInterfaceManager:DataPlayer_GetNation()))
end

function SoldierSale:initView()
    local nodes = self.m_nodes
    if self.m_rootNode then
        --self.m_rootNode:setPosition(cc.p(winSize.width / 2 , winSize.height / 2))
    end

    local function clickGo()
        CPPInterfaceManager:moveTOCamp()
        windowManager:removeUI("HuodongView")
    end

    local function clickGet()
        local IsRewardState= DataSoldierSale.SoldierSaleRewardState()
        if(IsRewardState==2) then
            CPPInterfaceManager:UI_ShowWarningMessage("loc_share_reward_have_got",0)
        elseif(IsRewardState==1) then
            for i = 1, 2 do
                local picStr = "resAnim"..tostring(i)
                local pic = self.m_rootNode:getNodeByName(picStr)
                local resIcon = pic:getNodeByName("resIcon")
                local n = 3
                if(i==1)then
                    n = 1
                end
                local resType = DataSoldierSale.getSoldierSaleInfo( n )
                local resNum = DataSoldierSale.getSoldierSaleInfo( n+1 )
                CPPInterfaceManager:UIEffect_FlyResourceIcon(resIcon, 0, 0, resType, resNum)
            end
            
            messageManager:sendForJson( 1101, 0 )
        end
    end
    local nation = CPPInterfaceManager:DataPlayer_GetNation()
    local nationName = Util.GetNationName(nation)
    local plistName = "yasuo_ui_" .. nationName
    animManager:useSpriteframesFromPath(plistName)
    local soldierId = DataSoldierSale.getSoldierSaleId()
    local spendNum = CPPInterfaceManager:GetArmyCountryData_Cost(soldierId,1)
    local spendSale = spendNum*DataSoldierSale.getSoldierSaleValue()
    local picname = CPPInterfaceManager:GetArmyCountryData_modelPicture(soldierId,nation)
    local soldiername = CPPInterfaceManager:GetArmyCountryData_Name(soldierId,nation)
    local maxNum= DataSoldierSale.getSoldierSaleMaxNum()

    nodes.icon = self.m_rootNode:getNodeByName("icon")
    nodes.icon2 = nodes.icon:getNodeByName("icon")
    nodes.imgFlag = nodes.icon:getNodeByName("flag")

    local skinName = nodes.imgFlag:getCurrentSkinName()
    local animName = nodes.imgFlag:getCurrentAnimName()
    nodes.imgFlag:changeFile("zc_flag_" .. nationName .. ".ani")
    nodes.imgFlag:playAnimation(animName)
    nodes.imgFlag:useSkin(skinName)
    nodes.icon:getLabelByName("nameTip"):setString(getStringInLang(soldiername))

    Util.SetSpriteFrame(nodes.icon2,picname)


    for i = 1, 2 do
        local picStr = "resAnim"..tostring(i)
        local pic = self.m_rootNode:getNodeByName(picStr)
        local n = 3
        if(i==1)then
            n = 1
        end
        local resType = DataSoldierSale.getSoldierSaleInfo( n )
        local resNum = DataSoldierSale.getSoldierSaleInfo( n+1 )
        pic:useSkin(tostring(resType))
        pic:getLabelByName("numLabel"):setString(tostring(resNum))
    end

    self.m_rootNode:getLabelByName("labelInfo7"):setString(tostring(spendNum))
    self.m_rootNode:getLabelByName("labelInfo6"):setString(tostring(spendSale))
    
    self.m_rootNode:getLabelByName("labelInfo1"):setString(getStringInLang("loc_badarmy_time_left"))
    self.m_rootNode:getLabelByName("labelInfo2"):setString(Util.TranslateArg("loc_army_discount_content_1",getStringInLang(soldiername)))
    self.m_rootNode:getLabelByName("labelInfo5"):setString(getStringInLang("loc_army_discount_content_2"))
    local str = Util.TranslateArg("loc_army_discount_mission",getStringInLang(soldiername))
    self.m_rootNode:getLabelByName("labelInfo3"):setString(Util.TranslateArg2(str,maxNum))
    self.m_rootNode:getLabelByName("labelInfo8"):setString(getStringInLang("loc_victoryreward"))
    self.m_rootNode:getLabelByName("labelInfo9"):setString(getStringInLang("loc_achievement_process"))

    nodes.btnGo = self.m_rootNode:getNodeByName("buttonOk")
    self.m_rootNode:getLabelByName("animOk/buttonLabel"):setString(getStringInLang("loc_pop_button_train"))

    nodes.btnGet = self.m_rootNode:getNodeByName("buttonGet")

    setNEButtonCallBack(nodes.btnGo, NEBattleEvent.NEButtonEventTouchUpInside, clickGo)
    setNEButtonCallBack(nodes.btnGet, NEBattleEvent.NEButtonEventTouchUpInside, clickGet)

    self:refeshSoldierSale()
end

function SoldierSale:refeshSoldierSale()
    local nodes = self.m_nodes
    local completeNum= DataSoldierSale.getSoldierSaleCompleteNum()
    local maxNum= DataSoldierSale.getSoldierSaleMaxNum()
    local strTime = CPPInterfaceManager:LString_formateRestEndTime(DataSoldierSale.getSoldierSaleEndTime())

    self.m_rootNode:getLabelByName("labelTime"):setString(strTime)
    self.m_rootNode:getLabelByName("labelInfo4"):setString(tostring(completeNum).."／"..tostring(maxNum))

    nodes.jindunode = self.m_rootNode:getNodeByName("jindunode")
    nodes.animGet = self.m_rootNode:getNodeByName("animGet")

    if(completeNum>=maxNum)then
        nodes.jindunode:setVisible(false)
        nodes.animGet:setVisible(true)
        local IsRewardState= DataSoldierSale.SoldierSaleRewardState()
        if(IsRewardState==2) then
            nodes.animGet:useSkin("F60")
            self.m_rootNode:getLabelByName("animGet/buttonLabel"):setString(getStringInLang("loc_shop_item_name_month_card_reward_got"))
        elseif(IsRewardState==1) then
            nodes.animGet:useSkin("F50")
            self.m_rootNode:getLabelByName("animGet/buttonLabel"):setString(getStringInLang("loc_achievement_claim"))
        end
    else
        nodes.jindunode:setVisible(true)
        nodes.animGet:setVisible(false)
    end
end

return SoldierSale
